#include <stdio.h>
#include <stdlib.h>
#include <qdos.h>
#include <qptr.h>
#include <time.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <csrvthg.h>
#include <database.h>

#define unixtoql 283996800              /* time conversion, 1970 to 1961 */

extern long dbid;
extern char inbound[];
extern char areaname[];
extern short areanum;
extern long pktfile;
extern unsigned short myzone,mynet,mynode,mypoint,myfake;
extern struct tm *now;
extern char address[];
extern long fchan;
extern char terminate[];
extern long rnum;

void intel( long chan, int value);
void sysvar(char *varname, char *ans, int sz);
int findref(long db, char *rec, struct fld_list fldef[],char *appcn);
int findanum(long db, char *rec, struct fld_list fldef[],char *appcn);

typedef struct
{
    char status;
    char msgnum[7];
    char date[8];
    char time[5];
    char msgto[25];
    char msgfrom[25];
    char subject[25];
    char password[12];
    char reply[8];
    char numblocks[6];
    char active;
    char confl;
    char confh;
    char numl;
    char numh;
    char tagline;
}  QWKHEADER;

#define BMAX 42

/*---------------------------------------------------------------------------*/
void add_to_pkt(QWKHEADER *hdr)
{
int ferr,f,c;
char lbuff[130];
char temp[80];
struct tm t;
time_t tp;
char *ptr;
int  find;
short a;
char aname[BMAX+2];
long fch = -1;
long dbd = -1;
long ich = -1;
long ibd = -1;
short rlen;
char *rq;

      a = hdr->confh;
      a *= 256;
      a += hdr->confl;
      if(a != areanum)
      {
        find = fsd_srch(dbid, findanum, &a);
        if (find >= 0)
        {
           strcpy(areaname,"AREA:");
           find = fsd_get(dbid, 3, BMAX, temp);
           if (find >= 0)
              temp[find] = '\0';
           if(temp[0] == '\0')
           {
             strcpy(areaname,"PBOX:");
             find = fsd_get(dbid, 2, BMAX, temp);
             if (find >= 0)
                temp[find] = '\0';
           }
           strcat(areaname,temp);
           strcat(areaname,"\r");
        }
        else
          areaname[0] = '\0';
      }
      (void)io_sbyte(pktfile,-1,2);     /* type 2,0 message */
      (void)io_sbyte(pktfile,-1,0);
      intel(pktfile,mynode);
      intel(pktfile,mynode);
      intel(pktfile,mynet);
      intel(pktfile,mynet);
      intel(pktfile,0x0100);            /* attributes: local */
      intel(pktfile,0);                 /* zero "cost" */
      ptr = hdr->time;                  /* read "written" time */
      t.tm_hour = atoi(ptr);
      ptr += 3;
      t.tm_min = atoi(ptr);
      t.tm_sec = 0;
      ptr = hdr->date;
      *(ptr+2)='\0';
      t.tm_mon = atoi(ptr)-1;
      ptr += 3;
      *(ptr+2)='\0';
      t.tm_mday = atoi(ptr);
      ptr += 3;
      *(ptr+2)='\0';
      t.tm_year = atoi(ptr);
      (void)strftime( temp, 22,         /* turn into ascii string */
            "%d %b %y  %H:%M:%S\0", &t);
      (void)io_sstrg(pktfile,-1,temp, 20); /* and write it out */
      ptr = (char *)&(hdr->msgfrom);    /* go to end of "to" name */
      ptr--;
      while (*ptr == ' ') ptr--;
      ptr++;
      *ptr = '\0';
      ptr = (char *)&(hdr->msgto);
      io_sstrg(pktfile,-1,ptr,1+strlen(ptr));
      ptr = (char *)&(hdr->subject);    /* go to end of "from" name */
      ptr--;
      while (*ptr == ' ') ptr--;
      ptr++;
      *ptr = '\0';
      ptr = (char *)&(hdr->msgfrom);
      io_sstrg(pktfile,-1,ptr,1+strlen(ptr));
      ptr = (char *)&(hdr->password);   /* go to end of subject */
      ptr--;
      while (*ptr == ' ') ptr--;
      ptr++;
      *ptr = '\0';
      ptr = (char *)&(hdr->subject);
      io_sstrg(pktfile,-1,ptr,1+strlen(ptr));
      io_sstrg(pktfile, -1, areaname, strlen(areaname));
      io_sbyte(pktfile, -1, 1);
      sprintf(temp,"MSGID: %s %08x\r",address,rnum);
      rnum++;
      io_sstrg(pktfile, -1, temp, strlen(temp));
      a = (short)atoi(hdr->reply);    /* see if it's a reply */
      if(a)
      {
        /*
            get area database name, create index name, search index
            for reply nr, read msgid which becomes replyid
        */
        find = fsd_get(dbid, 4, BMAX, aname);    /* area dbs filename */
        if (find >= 0)                           /* check theres a filename */
        {
          aname[find] = '\0';
          fch = io_open( aname, 1 );     /* open dbs read only */
          if (fch > 0 )
             dbd = fsd_open(fch);

          if (fch > 0 && dbd > 0 )
          {
            ptr = aname;
            ptr += strlen(aname);
            ptr -= 3;
            (void)strcpy(ptr,"idx");
            ich = io_open( aname, 1 );     /* open index read only */
            if (ich > 0 )
               ibd = fsd_open(ich);
            if (ich > 0 && ibd > 0 )
            {
              find = fsd_srch(ibd, findref, &a);  /* find the ref nr */
              if (find >= 0)
              {
                find = fsd_get(ibd, 1, BMAX, temp);
                if (find >= 0)
                {
                  temp[find] = '\0';
                  io_sbyte(pktfile, -1, 1);
                  io_sstrg(pktfile, -1,"REPLY: ", 7);
                  io_sstrg(pktfile, -1, temp, strlen(temp));
                  io_sbyte(pktfile, -1,13);
                }
              }
            }
            (void)fsd_close(ibd);
            (void)io_close(ich);
          }
          (void)fsd_close(dbd);
          (void)io_close(fch);
        }
      }
      for(f=atoi(hdr->numblocks); f>1; f--)
      {
        ferr = io_fstrg(fchan, 100, lbuff, 128);
        if(ferr < 0)
          break;
        for(c=0; c<ferr; c++)
        {
          if(lbuff[c] == '\xe3')        /* char 227, hard CR */
            lbuff[c] = 13;
          if(lbuff[c] == '\0')
            lbuff[c] = ' ';
        }
        io_sstrg(pktfile,-1,lbuff,ferr);
      }
      find = fsd_get(dbid, 6, BMAX, temp);
      if (find >= 0)
         temp[find] = '\0';
      if (strchr(temp,'E') != NULL)
      {
        /* if it's an echomail area, add a tagline */
        io_sbyte(pktfile,-1,13);
        rq = Request ("pbox","version",-1,&rlen);
        if (rq != NULL)
        {
          strcpy(temp,"--- Pbox v");
          strcat(temp,rq);
          io_sstrg(pktfile,-1,temp,strlen(temp));
          io_sbyte(pktfile,-1,13);
          free(rq);
          strcpy(temp," * Origin: ");
          rq = Request ("pbox","sysvar boardname",-1,&rlen);
          if (rq != NULL)
          {
            strcat(temp,rq);
            free(rq);
            strcat(temp," ");
            rq = Request ("pbox","sysvar phone_no",-1,&rlen);
            if (rq != NULL)
            {
              strcat(temp,rq);
              free(rq);
              strcat(temp," (");
              strcat(temp,address);
              strcat(temp,")");
              io_sstrg(pktfile,-1,temp,strlen(temp));
            }
          }
        }
      }
      io_sbyte(pktfile,-1,13);
      io_sstrg(pktfile,-1,"SEEN-BY: ",9);
      if(mypoint == 0)
        sprintf(temp,"%d/%d",mynet,mynode);
      else
        sprintf(temp,"%d/%d",myfake,mypoint);
      ptr = &temp[0];
      io_sstrg(pktfile,-1,ptr,strlen(ptr));
      io_sbyte(pktfile,-1,13);
      io_sbyte(pktfile,-1,1);
      io_sstrg(pktfile,-1,"PATH: ",6);
      io_sstrg(pktfile,-1,ptr,strlen(ptr));
      (void)io_sstrg(pktfile,-1,terminate,5);     /* terminate text */
}
/*---------------------------------------------------------------------------*/
void open_pkt(void)
{
char pktname[40];
char temp[40];
char *nptr;
short capable = 0x0001;
char *tokptr;
char *tptr;
int c;

   rnum++;
   sysvar("FIDONET_PNT",address,40);
   if (address[0] != '-')
   {
     tptr = &address[0];
     mypoint = (unsigned short) atoi(tptr);
   }
   sysvar("FIDONET",address,40);   /* get network z:n/d.p */
   if(address[0] == '-')
     strcpy(address,"0:0/0.0");
   strcpy(temp,address);
   tptr = &temp[0];
   tokptr  = strchr(tptr, ':');
   if(tokptr != NULL)
   {
     *tokptr = '\0';
     myzone = (unsigned short) atoi(tptr);
     tptr = tokptr+1;
   }
   tokptr  = strchr(tptr, '/');
   if(tokptr != NULL)
   {
     *tokptr = '\0';
     mynet = (unsigned short) atoi(tptr);
     tptr = tokptr+1;
   }
   tokptr  = strchr(tptr, '.');
   if(tokptr != NULL)
   {
     *tokptr = '\0';
     mypoint = (unsigned short) atoi(tokptr+1);
   }
   mynode = (unsigned short) atoi(tptr);

  sprintf(pktname,"%s%08x.PKT",inbound,rnum);
  rnum++;
  pktfile = io_open(pktname,3); /* open for overwrite */

  intel(pktfile,mynode);        /* entries in intel format */
  intel(pktfile,mynode);
  intel(pktfile,1900+(now->tm_year));
  intel(pktfile,now->tm_mon);
  intel(pktfile,now->tm_mday);
  intel(pktfile,now->tm_hour);
  intel(pktfile,now->tm_min);
  intel(pktfile,now->tm_sec);
  intel(pktfile,0);             /* baud is zeroed */
  intel(pktfile,2);             /* packet type 2+ */
  if(mypoint != 0)            /* use auxnet for points */
    intel(pktfile,0xffff);
  else
    intel(pktfile,mynet);
  intel(pktfile,mynet);
  intel(pktfile,0x01ff);        /* product code/version */
  for(c=1; c<5; c++)
    intel(pktfile,0);           /* password */
  intel(pktfile,myzone);        /* orig zone for Qmail */
  intel(pktfile,myzone);        /* dest zone for Qmail */
  if(mypoint != 0)              /* use auxnet for points */
    intel(pktfile,mynet);
  else
    intel(pktfile,0);           /* no auxnet for nodes */
  (void)io_sbyte(pktfile, -1, ((capable & 0xff00) >> 8));
  (void)io_sbyte(pktfile, -1, (capable & 0x00ff));
  intel(pktfile,0x0100);       /* revision level */
  intel(pktfile,capable);      /* capability level */
  intel(pktfile,myzone);       /* for FrontDoor etc. */
  intel(pktfile,myzone);       /* for FrontDoor etc. */
  intel(pktfile,mypoint);      /* for FrontDoor etc. */
  intel(pktfile,mypoint);      /* for FrontDoor etc. */
  intel(pktfile,0);            /* filler */
  intel(pktfile,0);            /* filler */
}
/*---------------------------------------------------------------------------*/
void close_pkt(void)
{
    io_sbyte(pktfile,100,'\0');         /* two zeros to terminate */
    io_sbyte(pktfile,100,'\0');
    io_close(pktfile);
}
